'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _testSetup = require('./test-setup');

var _index = require('../src/index');

var index = _interopRequireWildcard(_index);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

/*
 ******************************************************************************
 Copyright (c) 2016 Particle Industries, Inc.  All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation, either
 version 3 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************
 */

var fs = require('fs');
var path = require('path');

describe('public package interface', function () {
	it('exports a bunch of stuff', function () {
		var expectedExports = [
		// librepo.js
		'LibraryRepositoryError', 'LibraryNotFoundError', 'LibraryFormatError', 'LibraryRepository', 'Library', 'LibraryFile', 'MemoryLibraryFile', 'AbstractLibrary', 'AbstractLibraryRepository',

		// librepo_build.js
		'BuildLibrary', 'BuildLibraryRepository',

		// librepo_fs.js
		'libraryProperties', 'FileSystemLibrary', 'NamingStrategy', 'FileSystemLibraryFile', 'sparkDotJson', 'FileSystemNamingStrategy', 'FileSystemLibraryRepository', 'mapActionDir', 'getdirs', 'isLibraryExample',

		// libinit.js
		'LibraryInitGeneratorMixin', 'buildLibraryInitGeneratorClass',

		// librepo_cloud.js
		'CloudLibrary', 'CloudLibraryRepository',

		// validation.js
		'validateField', 'validateMetadata', 'validateLibrary', 'formatValidationError', 'formatValidationErrors', 'validationMessage',

		// extra
		'appRoot', 'resourcesDir'];
		(0, _testSetup.expect)((0, _keys2.default)(index)).to.eql(expectedExports);
	});
});

describe('resourcesDir', function () {
	it('can fetch resources dir', function () {
		var dir = index.resourcesDir();
		return (0, _testSetup.expect)(fs.existsSync(dir)).to.be.true;
	});

	it('can fetch libraries via approot', function () {
		var dir = index.resourcesDir();
		var libs = path.join(dir, 'libraries');
		return (0, _testSetup.expect)(fs.existsSync(libs)).to.be.true;
	});
});
//# sourceMappingURL=index.spec.js.map