'use strict';

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _isIterable2 = require('babel-runtime/core-js/is-iterable');

var _isIterable3 = _interopRequireDefault(_isIterable2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = (0, _getIterator3.default)(arr), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if ((0, _isIterable3.default)(Object(arr))) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ******************************************************************************
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           Copyright (c) 2016 Particle Industries, Inc.  All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           This program is free software; you can redistribute it and/or
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           modify it under the terms of the GNU Lesser General Public
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           License as published by the Free Software Foundation, either
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           version 3 of the License, or (at your option) any later version.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           This program is distributed in the hope that it will be useful,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           but WITHOUT ANY WARRANTY; without even the implied warranty of
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           Lesser General Public License for more details.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           You should have received a copy of the GNU Lesser General Public
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           License along with this program; if not, see <http://www.gnu.org/licenses/>.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ******************************************************************************
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */

exports.makeTestLib = makeTestLib;
exports.makeCompleteV2Lib = makeCompleteV2Lib;

var _testSetup = require('./test-setup');

var _concatStream = require('concat-stream');

var _concatStream2 = _interopRequireDefault(_concatStream);

var _librepo = require('../src/librepo');

var _librepo_fs = require('../src/librepo_fs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var promisify = require('es6-promisify');
var fs = require('fs');
var path = require('path');

var libFileContents = { 'h': '// a header file', cpp: '// a cpp file' };

/**
 * Creates a mock filesystem structure for a library.
 * @param {String} name The name of the library.
 * @param {Boolean} metadata Adds the library properties file when true.
 * @returns {Object} representing the mock file system.
 */
function makeFsLib(name) {
	var metadata = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

	var result = {};
	result[name + '.h'] = '// a header file';
	result[name + '.cpp'] = '// a cpp file';
	if (metadata) {
		result[_librepo_fs.libraryProperties] = 'name=' + name + '\nversion=1.2.3\n';
	}
	return result;
}

var libFS = {
	'mydir': {
		'lib1': makeFsLib('lib1'),
		'yaya': makeFsLib('yaya'),
		'zzz': makeFsLib('zzz', false),
		'hello.txt': 'hello.txt',
		'.profile': { '.secret': 'sssh!' }
	}
};

var libData = {
	'lib1': { lib: true },
	'yaya': { lib: true },
	'zzz': { lib: false },
	'hello.txt': { lib: false },
	'.profile': { lib: false }
};

function makeLibrary(name, definition, files) {
	var lib = {
		name: name,
		metadata: definition,
		files: function resolveFile() {
			return _promise2.default.resolve(files);
		},
		definition: function resolveDefinition() {
			return _promise2.default.resolve(definition);
		}
	};
	return lib;
}

function fetchContent(libraryFile) {
	return new _promise2.default(function (resolve) {
		var concat = require('concat-stream');
		var store = concat(resolve);
		libraryFile.content(store);
	});
}

function sourcesOnly(files) {
	return files.filter(function (file) {
		return file.kind === 'source';
	});
}

function libsFilesEqual(expected, actual) {
	return _promise2.default.all([expected, actual]).then(function (results) {
		var _results = _slicedToArray(results, 2),
		    expectedFiles = _results[0],
		    actualFiles = _results[1];

		expectedFiles = sourcesOnly(expectedFiles);
		actualFiles = sourcesOnly(actualFiles);
		(0, _testSetup.expect)(actualFiles.length).to.equal(expectedFiles.length);
		var contentsSame = [];

		for (var i = 0; i < actualFiles.length; i++) {
			var expectedFile = expectedFiles[i];
			var actualFile = actualFiles[i];

			(0, _testSetup.expect)(actualFile.name).to.be.equal(expectedFile.name);
			(0, _testSetup.expect)(actualFile.kind).to.be.equal(expectedFile.kind);
			(0, _testSetup.expect)(actualFile.extension).to.be.equal(expectedFile.extension);

			var checkContents = _promise2.default.all([fetchContent(expectedFile), fetchContent(actualFile)]).then(function (contents) {
				var _contents = _slicedToArray(contents, 2),
				    expectedContent = _contents[0],
				    actualContent = _contents[1];

				(0, _testSetup.expect)(actualContent.toString()).to.be.equal(expectedContent.toString());
			});
			contentsSame.push(checkContents);
		}

		return _promise2.default.all(contentsSame);
	});
}

function libDefinitionsEqual(expected, actual) {
	return _promise2.default.all([expected, actual]).then(function (defs) {
		var _defs = _slicedToArray(defs, 2),
		    expectedDefinition = _defs[0],
		    actualDefinition = _defs[1];

		(0, _testSetup.expect)(actualDefinition).to.be.deep.equal(expectedDefinition);
	});
}

function libsEqual(expected, actual) {
	(0, _testSetup.expect)(actual.name).to.be.equal(expected.name);
	return _promise2.default.all([libsFilesEqual(expected.files(), actual.files()), libDefinitionsEqual(expected.definition(), actual.definition())]);
}

/**
 * Validates the contents of a directory in the filesystem contains the files given by the spec. The filesytem may
 * contain additional files, beyond what is in the expected spec. These aren't tested.
 * @param {string} path The location in the file system containing the directory structure.
 * @param {object} expected The File system structure. The property name is the file system item - strings represent files,
 * objects represent subdirectories.
 * @return {Promise} promise will check the file system
 */
function checkFileSystem(path, expected) {
	var checks = [];
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		var _loop = function _loop() {
			var _step$value = _slicedToArray(_step.value, 2),
			    key = _step$value[0],
			    value = _step$value[1];

			var fun = void 0;
			var promises = [];
			if (typeof value == 'string') {
				fun = function fun() {
					var readFile = promisify(fs.readFile);
					return readFile(path + '/' + key).then(function (contents) {
						(0, _testSetup.expect)(contents.toString()).to.be.equal(value);
					});
				};
			} else {
				fun = function fun() {
					var stat = promisify(fs.stat);
					return stat(path + '/' + key).then(function (stat) {
						(0, _testSetup.expect)(stat.isDirectory()).to.be.true;
					});
				};
				// check that the directory exists in the filesystem
				promises = checkFileSystem(path + '/' + key, value);
			}
			// ensure the directory is checked first before checking subcontents
			checks.push(_promise2.default.resolve().then(fun));
			checks.concat(promises);
		};

		for (var _iterator = (0, _getIterator3.default)((0, _entries2.default)(expected)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			_loop();
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}

	return checks;
}

/**
 * Does a white-box test of the files created for a library, since that is part of the externally
 * visible contact.
 * @param {Library} lib       The library to verify
 * @param {string} root      The root directory.
 * @return {Promise} which resolves to success
 */
function libFiles(lib, root) {
	var name = lib.name;
	var path = root + '/' + name;
	// the spec for the lib.
	var expected = makeFsLib(name);

	return _promise2.default.all(checkFileSystem(path, expected));
}

function makeTestLib(name, version) {
	var lib = makeLibrary(name, { name: name, version: version }, [new _librepo.MemoryLibraryFile(name, 'source', 'cpp', '// a cpp file', 1), new _librepo.MemoryLibraryFile(name, 'source', 'h', '// a header file', 2), new _librepo.MemoryLibraryFile(name, 'example', 'ino', '// some content ino', 3)]);
	return lib;
}

function makeCompleteV2Lib(name, version) {
	var lib = makeLibrary(name, { name: name, version: version }, [new _librepo.MemoryLibraryFile('src/' + name, 'source', 'cpp', '// a cpp file', 1), new _librepo.MemoryLibraryFile('src/' + name, 'source', 'h', '// a header file', 2), new _librepo.MemoryLibraryFile('README', 'source', 'md', '# readme', 3), new _librepo.MemoryLibraryFile('LICENSE', 'source', '', '# license', 4)]);
	return lib;
}

/*
function mock(...args) {
	const mockfs = require('mock-fs');
	mock.restore = mockfs.restore;
	return mockfs(...args);
}
*/
describe('File System Mock', function () {

	function mkdir(name) {
		if (!fs.existsSync(name)) {
			fs.mkdirSync(name);
		}
	}

	var mock = require('mock-fs');

	beforeEach(function (done) {
		mock(libFS);
		done();
	});

	afterEach(function (done) {
		mock.restore();
		done();
	});

	describe('getdirs', function () {
		it('lists correct subdirectories', function () {
			return (0, _librepo_fs.getdirs)('mydir/').then(function (dirs) {
				(0, _testSetup.expect)(dirs).to.contain('lib1');
				(0, _testSetup.expect)(dirs).to.contain('yaya');
				(0, _testSetup.expect)(dirs).to.contain('zzz');
				(0, _testSetup.expect)(dirs).to.not.contain('hello.txt');
				(0, _testSetup.expect)(dirs).to.not.contain('.profile2');
			});
		});
	});

	describe('Library Repository', function () {
		// eslint-disable-line max-statements
		it('constructor adds trailing slash when missing', function () {
			var dir = '';
			var sut = new _librepo_fs.FileSystemLibraryRepository(dir);
			(0, _testSetup.expect)(sut.path).to.be.equal('/');
		});

		it('constructor does not add a trailing slash when already present', function () {
			var dir = '/';
			var sut = new _librepo_fs.FileSystemLibraryRepository(dir);
			(0, _testSetup.expect)(sut.path).to.be.equal('/');
		});

		it('appends a directory with a trailing slash', function () {
			var dir = '/';
			var sut = new _librepo_fs.FileSystemLibraryRepository(dir);
			(0, _testSetup.expect)(sut.directory('abc')).to.be.equal('/abc/');
		});

		it('doesn\'t append a slash if the directory is empty', function () {
			var dir = '/123/';
			var sut = new _librepo_fs.FileSystemLibraryRepository(dir);
			(0, _testSetup.expect)(sut.directory('')).to.be.equal('/123/');
		});

		it('nameToFs is currently a no-op', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('');
			var name = 'abc$§/0\0';
			(0, _testSetup.expect)(sut.nameToFs(name)).to.equal(name);
		});

		it('extension splits filename at a dot when present', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('');
			var result = sut.extension('abc.txt');
			(0, _testSetup.expect)(result[1]).to.equal('abc');
			(0, _testSetup.expect)(result[0]).to.equal('txt');
		});

		it('extension returns basename when dot not present', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('');
			var result = sut.extension('abc');
			(0, _testSetup.expect)(result[1]).to.equal('abc');
			(0, _testSetup.expect)(result[0]).to.equal('');
		});

		it('extension returns empty extension with dot in last position', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('');
			var result = sut.extension('abc.');
			(0, _testSetup.expect)(result[1]).to.equal('abc');
			(0, _testSetup.expect)(result[0]).to.equal('');
		});

		it('can list exising libraries', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var promise = sut.names().then(function (names) {
				(0, _testSetup.expect)(names).to.contain('lib1');
				(0, _testSetup.expect)(names).to.contain('yaya');
				(0, _testSetup.expect)(names).to.not.contain('zzz');
			});
			return promise;
		});

		it('can fetch a single library directly, named implicitly', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir/lib1', _librepo_fs.FileSystemNamingStrategy.DIRECT);
			return (0, _testSetup.expect)(sut.fetch('')).to.eventually.be.ok;
		});

		describe('can fetch libraries by name', function () {
			var _iteratorNormalCompletion2 = true;
			var _didIteratorError2 = false;
			var _iteratorError2 = undefined;

			try {
				var _loop2 = function _loop2() {
					var _step2$value = _slicedToArray(_step2.value, 2),
					    name = _step2$value[0],
					    data = _step2$value[1];

					it('can fetch library \'' + name + '\' by name', function () {
						var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
						var promiseLib = sut.fetch(name);
						(0, _testSetup.expect)(promiseLib).to.be.ok;
						if (data.lib) {
							return promiseLib.then(function (lib) {
								(0, _testSetup.expect)(lib).has.property('name').that.is.equal(name);
								return lib.files().then(function (files) {
									(0, _testSetup.expect)(files.length).to.be.equal(2);
									var checkContents = [];
									var _iteratorNormalCompletion3 = true;
									var _didIteratorError3 = false;
									var _iteratorError3 = undefined;

									try {
										var _loop3 = function _loop3() {
											var file = _step3.value;

											(0, _testSetup.expect)(file.name).to.be.equal(name);
											(0, _testSetup.expect)(file.extension).to.be.oneOf(['cpp', 'h']);
											// verify contents
											var expectedContents = libFileContents[file.extension];
											checkContents.push(new _promise2.default(function (resolve) {
												var store = (0, _concatStream2.default)(function (content) {
													(0, _testSetup.expect)(content.toString()).to.be.equal(expectedContents);
													resolve();
												});
												file.content(store);
											}));
										};

										for (var _iterator3 = (0, _getIterator3.default)(files), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
											_loop3();
										}
									} catch (err) {
										_didIteratorError3 = true;
										_iteratorError3 = err;
									} finally {
										try {
											if (!_iteratorNormalCompletion3 && _iterator3.return) {
												_iterator3.return();
											}
										} finally {
											if (_didIteratorError3) {
												throw _iteratorError3;
											}
										}
									}

									return _promise2.default.all(checkContents);
								});
							});
						} else {
							return (0, _testSetup.expect)(promiseLib).eventually.rejectedWith(/library '.*' not found.*/);
						}
					});
				};

				for (var _iterator2 = (0, _getIterator3.default)((0, _entries2.default)(libData)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
					_loop2();
				}
			} catch (err) {
				_didIteratorError2 = true;
				_iteratorError2 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion2 && _iterator2.return) {
						_iterator2.return();
					}
				} finally {
					if (_didIteratorError2) {
						throw _iteratorError2;
					}
				}
			}
		});

		it('can remove the id property from metadata', function () {
			var md = { name: 'funbuns', 'id': '123' };
			var sut = new _librepo_fs.FileSystemLibraryRepository('not used');
			(0, _testSetup.expect)(sut.removeId(md)).to.be.deep.equal({ name: 'funbuns' });
		});

		it('can fetch a filename from the library anem, file base and file extension', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			(0, _testSetup.expect)(sut.libraryFileName('mylib', 'file', 'ext')).to.be.equal('mydir/mylib/file.ext');
		});

		it('can determine source code files', function () {
			var isSourceData = { 'abcd/a.txt': false, '123/a.c': true, 'yaya/a.cpp': true, '../a.properties': false };

			var _iteratorNormalCompletion4 = true;
			var _didIteratorError4 = false;
			var _iteratorError4 = undefined;

			try {
				var _loop4 = function _loop4() {
					var _step4$value = _slicedToArray(_step4.value, 2),
					    name = _step4$value[0],
					    isSource = _step4$value[1];

					it('can determine if file \'' + name + '\' is source code', function () {
						var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
						(0, _testSetup.expect)(sut.isSourceFileName(name)).to.be.equal(isSource);
					});
				};

				for (var _iterator4 = (0, _getIterator3.default)((0, _entries2.default)(isSourceData)), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
					_loop4();
				}
			} catch (err) {
				_didIteratorError4 = true;
				_iteratorError4 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion4 && _iterator4.return) {
						_iterator4.return();
					}
				} finally {
					if (_didIteratorError4) {
						throw _iteratorError4;
					}
				}
			}
		});

		it('can add a library', function () {
			var name = 'belgianblondeguzzler';
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var lib = makeTestLib(name, '1.2.3');
			var result = sut.add(lib).then(function () {
				return sut.fetch(name);
			}).then(function (fetched) {
				return _promise2.default.all([libsEqual(lib, fetched), libFiles(lib, 'mydir')]);
			});

			return result;
		});

		var desc = 'name=abcd\n' + 'version=1.2.3\n' + 'license=dummy\n' + 'author=Mr Big\n' + 'sentence=Fixes the world\n' + 'architectures=avr,particle-photon,spark-core\n' + 'dot.notation=supported';

		function checkProps(desc) {
			(0, _testSetup.expect)(desc.name).to.be.equal('abcd');
			(0, _testSetup.expect)(desc.version).to.be.equal('1.2.3');
			(0, _testSetup.expect)(desc.license).to.be.equal('dummy');
			(0, _testSetup.expect)(desc.author).to.be.equal('Mr Big');
			(0, _testSetup.expect)(desc.description).to.be.equal('Fixes the world');
			(0, _testSetup.expect)(desc.architectures).to.be.eql(['avr', 'particle-photon', 'spark-core']);
			//expect(desc['dot']).to.equal({notation:'supported'});
			(0, _testSetup.expect)(desc['dot.notation']).to.equal('supported');
		}

		it('can read a v2 descriptor', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var path = 'mydir/test.propertes';
			fs.writeFileSync(path, desc);
			return sut.readDescriptorV2('abcd', path).then(checkProps);
		});

		it('prepares v2 descriptor and doesn\'t modify an existing sentence property', function () {
			var desc = { sentence: 'abc', description: 'def' };
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			(0, _testSetup.expect)(sut.prepareDescriptorV2(desc)).to.be.deep.equal({ sentence: 'abc', description: 'def' });
		});

		it('prepares v2 descriptor by setting the sentence property if not defined', function () {
			var desc = { description: 'def' };
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			(0, _testSetup.expect)(sut.prepareDescriptorV2(desc)).to.be.deep.equal({ sentence: 'def', description: 'def' });
		});

		it('fails to read a v2 descriptor when the name doesn\'t match', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var path = 'mydir/test.propertes';
			fs.writeFileSync(path, desc);
			return (0, _testSetup.expect)(sut.readDescriptorV2('noname', path)).eventually.be.rejected.and.deep.equal(new _librepo.LibraryFormatError(sut, 'noname', 'name in descriptor does not match directory name'));
		});

		it('can build a fully populated v2 descriptor', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var content = sut.buildV2Descriptor({
				name: 'abcd', version: '1.2.3', license: 'dummy', author: 'Mr Big', 'description': 'Fixes the world',
				architectures: ['particle-photon', 'particle-p1']
			});
			(0, _testSetup.expect)(content).to.be.equal('name=abcd\n' + 'version=1.2.3\n' + 'license=dummy\n' + 'author=Mr Big\n' + 'sentence=Fixes the world\n' + 'architectures=particle-photon,particle-p1\n');
		});

		it('can build an empty v2 descriptor', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var content = sut.buildV2Descriptor({
				name: 'abcd', version: '1.2.3'
			});
			(0, _testSetup.expect)(content).to.be.equal('name=abcd\n' + 'version=1.2.3\n');
		});

		it('can read a v1 descriptor', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			fs.writeFileSync('mydir/test.json', '{"name":"myname", "description":"desc"}');
			(0, _testSetup.expect)(sut.readFileJSON('name_not_used', 'mydir/test.json')).to.eventually.deep.equal({ name: 'myname', description: 'desc' });
		});

		it('rejects an invalid v1 descriptor', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			fs.writeFileSync('mydir/test.json', '{"name":"myname, "description":"desc"}');
			(0, _testSetup.expect)(sut.readFileJSON('somename', 'mydir/test.json')).to.eventually.be.rejected.and.deep.equal(new _librepo.LibraryFormatError(sut, 'somename', 'Error parsing file "mydir/test.json"'));
		});

		describe('layout', function () {

			it('throws exception for layout if library directory does not exist', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				var name = 'abcd__';
				var result = sut.getLibraryLayout(name);
				return (0, _testSetup.expect)(result).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, name));
			});

			it('can detect legacy layout', function () {
				mkdir('mydir');
				fs.mkdirSync('mydir/legacy');
				fs.writeFileSync('mydir/legacy/spark.json', '');
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return (0, _testSetup.expect)(sut.getLibraryLayout('legacy')).to.eventually.equal(1);
			});

			it('can detect v2 layout', function () {
				mkdir('mydir');
				mkdir('mydir/v2');
				fs.writeFileSync('mydir/v2/library.properties', '');
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return (0, _testSetup.expect)(sut.getLibraryLayout('v2')).to.eventually.equal(2);
			});

			it('can detect invalid layout', function () {
				mkdir('mydir');
				mkdir('mydir/invalid');
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return (0, _testSetup.expect)(sut.getLibraryLayout('invalid')).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, 'invalid'));
			});

			it('can write legacy layout', function () {
				var name = 'legacylib';
				var lib = makeTestLib(name, '1.2.3'); // a library object in memory.

				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				var result = sut.add(lib, 1).then(function () {
					return sut.getLibraryLayout(name);
				});
				return (0, _testSetup.expect)(result).to.eventually.equal(1);
			});

			function buildLibDir() {
				var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'testlib';

				mkdir('mydir');
				var libdir = path.join('mydir', name);
				mkdir(libdir);
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return [sut, name, libdir];
			}

			it('rejects a library layout when library.properties is a directory', function () {
				var _buildLibDir = buildLibDir(),
				    _buildLibDir2 = _slicedToArray(_buildLibDir, 3),
				    sut = _buildLibDir2[0],
				    name = _buildLibDir2[1],
				    libdir = _buildLibDir2[2];

				mkdir(path.join(libdir, _librepo_fs.libraryProperties));
				return (0, _testSetup.expect)(sut.getLibraryLayout(name)).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, name));
			});

			it('rejects a library layout when spark.json is a directory', function () {
				var _buildLibDir3 = buildLibDir(),
				    _buildLibDir4 = _slicedToArray(_buildLibDir3, 3),
				    sut = _buildLibDir4[0],
				    name = _buildLibDir4[1],
				    libdir = _buildLibDir4[2];

				mkdir(path.join(libdir, _librepo_fs.sparkDotJson));
				return (0, _testSetup.expect)(sut.getLibraryLayout(name)).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, name));
			});

			it('rejects a library layout when no metadata is present', function () {
				var _buildLibDir5 = buildLibDir(),
				    _buildLibDir6 = _slicedToArray(_buildLibDir5, 2),
				    sut = _buildLibDir6[0],
				    name = _buildLibDir6[1];

				return (0, _testSetup.expect)(sut.getLibraryLayout(name)).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, name));
			});

			it('rejects a library layout when no directory is present', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				var name = 'whatever';
				return (0, _testSetup.expect)(sut.getLibraryLayout(name)).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, name));
			});

			it('rejects a library layout when expected location is a file', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				var name = 'whatever';
				fs.writeFileSync(path.join('mydir', name, ''));
				return (0, _testSetup.expect)(sut.getLibraryLayout(name)).to.eventually.be.rejected.deep.equal(new _librepo.LibraryNotFoundError(sut, name));
			});
		});

		describe('migrate', function () {
			it('can migrate source file', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				var testSource = '\n\t\t\t\t#pragma don\'t change me\n\t\t\t\t#include "mylib/mylib.h"\n\t\t\t\t  #include \'mylib\\mylib.h\'\n\t\t\t\t  #include "mylib2/mylib2.h"\n\t\t\t\t  // note this is perverse and beyond what reasonable code does\n\t\t\t\t  "#include \'mylib/mylib_is_best.h\'"\n\t\t\t\t  //#include \'mylib/mylib_is_best.h\'\n\t\t\t\t';
				var expected = '\n\t\t\t\t#pragma don\'t change me\n\t\t\t\t#include "mylib.h"\n\t\t\t\t  #include \'mylib.h\'\n\t\t\t\t  #include "mylib2/mylib2.h"\n\t\t\t\t  // note this is perverse and beyond what reasonable code does\n\t\t\t\t  "#include \'mylib_is_best.h\'"\n\t\t\t\t  //#include \'mylib_is_best.h\'\n\t\t\t\t';

				var actual = sut.migrateSourcecode(testSource, 'mylib');
				(0, _testSetup.expect)(actual).to.be.equal(expected);
			});

			it('can migrate with special regex characters', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');

				var testSource = '\n\t\t\t\t#include "mylib++../mylib++...h"\n\t\t\t\t';
				var expected = '\n\t\t\t\t#include "mylib++...h"\n\t\t\t\t';
				var actual = sut.migrateSourcecode(testSource, 'mylib++..');
				(0, _testSetup.expect)(actual).to.eql(expected);
			});
		});

		describe('fileStat', function () {
			it('retrieves a null value for a non-existent file', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return (0, _testSetup.expect)(sut.fileStat('$$$.@@@1')).to.eventually.be.equal(null);
			});
		});

		describe('mkdirIfNeeded', function () {
			it('raises no error when the directory already exists', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return (0, _testSetup.expect)(sut.mkdirIfNeeded('mydir')).to.eventually.not.reject;
			});

			it('mkdir raises error if something other than "EEXIST"', function () {
				var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
				return (0, _testSetup.expect)(sut.mkdirIfNeeded('mydir/:/!|,')).to.eventually.reject;
			});
		});

		it('createDirectory can create a nested directory', function () {
			var sut = new _librepo_fs.FileSystemLibraryRepository('mydir');
			var dir = 'one/two/three';
			sut.createDirectory(dir);
			sut.createDirectory(dir); // do it again so we exercise the already exists case.
			(0, _testSetup.expect)(dir).to.be.a.directory;
		});
	});

	describe('File system naming strategies', function () {
		describe('Name Strategy', function () {
			var sut = _librepo_fs.FileSystemNamingStrategy.BY_NAME;
			it('returns the library name for the library ident', function () {
				(0, _testSetup.expect)(sut.toName({ name: 'finbarr' })).to.be.equal('finbarr');
			});

			it('returns the same name for filesystem', function () {
				(0, _testSetup.expect)(sut.nameToFilesystem('abcd')).to.be.equal('abcd');
			});

			it('matches the same name', function () {
				return (0, _testSetup.expect)(sut.matchesName({ name: 'abcd' }, 'abcd')).to.be.true;
			});
		});
	});

	describe('Name@Version Strategy', function () {
		var sut = _librepo_fs.FileSystemNamingStrategy.BY_NAME_AT_VERSION;

		it('returns the library name@version for the library ident', function () {
			(0, _testSetup.expect)(sut.toName({ name: 'finbarr', version: 'fnarr' })).to.be.equal('finbarr@fnarr');
		});

		it('returns the same name for filesystem', function () {
			(0, _testSetup.expect)(sut.nameToFilesystem('abcd')).to.be.equal('abcd');
		});

		it('matches the same name@version', function () {
			return (0, _testSetup.expect)(sut.matchesName({ name: 'abcd', version: '1' }, 'abcd@1')).to.be.true;
		});
	});

	describe('Direct Strategy', function () {
		var sut = _librepo_fs.FileSystemNamingStrategy.DIRECT;
		it('returns the library name for the library ident', function () {
			(0, _testSetup.expect)(sut.toName({ name: 'finbarr', version: 'fnarr' })).to.be.equal('finbarr');
		});

		it('returns the empty name for filesystem', function () {
			(0, _testSetup.expect)(sut.nameToFilesystem('abcd')).to.be.equal('');
		});

		it('matches the same name', function () {
			return (0, _testSetup.expect)(sut.matchesName({ name: 'abcd', version: '1' }, 'abcd')).to.be.true;
		});

		it('matches the empty string', function () {
			return (0, _testSetup.expect)(sut.matchesName({ name: 'abcd', version: '1' }, '')).to.be.true;
		});

		it('provides the name by reading the library in the directory', function () {
			var mockRepo = {};
			mockRepo.descriptorFileV2 = _testSetup.sinon.stub().returns('file');
			mockRepo.readDescriptorV2 = _testSetup.sinon.stub().returns(_promise2.default.resolve({ name: 'abcd' }));
			mockRepo.fileStat = _testSetup.sinon.stub().returns(_promise2.default.resolve({ isFile: function isFile() {
					return true;
				} }));

			// const filePath = this.descriptorFileV2(name);
			// return this.readDescriptorV2(name, filePath)
			return sut.names(mockRepo).then(function (names) {
				(0, _testSetup.expect)(names).to.be.deep.equal(['abcd']);
				(0, _testSetup.expect)(mockRepo.descriptorFileV2).to.have.been.calledWith('');
				(0, _testSetup.expect)(mockRepo.readDescriptorV2).to.have.been.calledOnce;
				(0, _testSetup.expect)(mockRepo.readDescriptorV2).to.have.been.calledWith('', 'file');
				(0, _testSetup.expect)(mockRepo.fileStat).to.have.been.calledOnce;
				(0, _testSetup.expect)(mockRepo.fileStat).to.have.been.calledWith('file');
			});
		});

		it('is not writable', function () {
			var repo = new _librepo_fs.FileSystemLibraryRepository('.', sut);
			return (0, _testSetup.expect)(repo.add({ metadata: { name: 'test' } })).to.be.rejected.and.eventually.have.property('name').equal('LibraryRepositoryError');
		});

		it('can retrieve a library by default', function () {
			var repo = new _librepo_fs.FileSystemLibraryRepository('./mydir/lib1', sut);
			return repo.fetch('').then(function (lib) {
				(0, _testSetup.expect)(lib.name).to.be.equal('lib1');
			});
		});

		it('can retrieve a library by name', function () {
			var repo = new _librepo_fs.FileSystemLibraryRepository('./mydir/lib1', sut);
			return repo.fetch('lib1').then(function (lib) {
				(0, _testSetup.expect)(lib.name).to.be.equal('lib1');
			});
		});

		it('throws LibraryNotFoundError if the requested name does not match the library name', function () {
			var repo = new _librepo_fs.FileSystemLibraryRepository('./mydir/lib1', sut);
			return (0, _testSetup.expect)(repo.fetch('lib2')).to.eventually.reject;
		});

		it('returns no names if the directory is not a valid library', function () {
			var repo = new _librepo_fs.FileSystemLibraryRepository('./mydir/zzz', sut);
			return (0, _testSetup.expect)(repo.names()).to.eventually.deep.equal([]);
		});

		it('throws library not found error for default name when directory is not a valid library', function () {
			var repo = new _librepo_fs.FileSystemLibraryRepository('./mydir/zzz', sut);
			return (0, _testSetup.expect)(repo.fetch('')).to.be.rejected.and.eventually.has.property('name').equal('LibraryNotFoundError');
		});
	});

	describe('addAdapter', function () {
		var sut = void 0,
		    callback = void 0;

		beforeEach(function () {
			sut = new _librepo_fs.FileSystemLibraryRepository('./mydir', _librepo_fs.FileSystemNamingStrategy.DIRECT);
			callback = _testSetup.sinon.stub();
		});

		it('raises an error when the layout is not v2', function () {
			sut.fileStat = _testSetup.sinon.stub().withArgs('somedir').returns(_promise2.default.resolve({ isDirectory: function isDirectory() {
					return true;
				} }));
			sut._addAdapters = _testSetup.sinon.spy();
			sut.getLibraryLayout = _testSetup.sinon.stub().returns(_promise2.default.resolve(1));
			// when
			return sut.addAdapters(callback, 'abcd', 'somedir').then(function () {
				throw Error('expected an exception');
			}).catch(function (error) {
				(0, _testSetup.expect)(error).to.deep.equal(sut._requireV2Format('abcd'));
			});
		});

		it('raises an error when the target directory does not exist', function () {
			sut.fileStat = _testSetup.sinon.stub().withArgs('somedir').returns(_promise2.default.resolve({ isDirectory: function isDirectory() {
					return false;
				} }));
			sut._addAdapters = _testSetup.sinon.spy();
			sut.getLibraryLayout = _testSetup.sinon.stub().returns(_promise2.default.resolve(2));
			// when
			return sut.addAdapters(callback, 'abcd', 'somedir').then(function () {
				throw Error('expected an exception');
			}).catch(function (error) {
				(0, _testSetup.expect)(error).to.deep.equal(sut._targetDirectoryDoesNotExist('somedir'));
			});
		});

		it('calls _addAdapter when the layout is v2 and the directory exists', function () {
			sut.fileStat = _testSetup.sinon.stub().withArgs('somedir').returns(_promise2.default.resolve({ isDirectory: function isDirectory() {
					return true;
				} }));
			sut._addAdapters = _testSetup.sinon.spy();
			sut.getLibraryLayout = _testSetup.sinon.stub().returns(_promise2.default.resolve(2));
			// when
			return sut.addAdapters(callback, 'abcd', 'somedir').then(function () {
				(0, _testSetup.expect)(sut._addAdapters).to.have.been.calledOnce;
				(0, _testSetup.expect)(sut._addAdapters).to.have.been.calledWith(callback, 'abcd', 'somedir');
			});
		});

		it('adds the library name to the target directory', function () {
			// given
			sut.fetch = _testSetup.sinon.stub().returns(_promise2.default.resolve(new _librepo.AbstractLibrary('abc')));
			sut._addAdaptersImpl = _testSetup.sinon.stub().returns(_promise2.default.resolve(123));
			// when

			return sut._addAdapters(callback, 'abc', 'mydir').then(function (result) {
				(0, _testSetup.expect)(result).to.equal(123);

				(0, _testSetup.expect)(sut._addAdaptersImpl).to.be.calledOne;
				(0, _testSetup.expect)(sut._addAdaptersImpl).to.be.calledWith(callback, 'mydir/abc', 'mydir/src');
			});
		});

		it('adds adapter files recursively and does not recurse into adapter directories', function () {
			// given
			fs.mkdirSync('mydir/lib');
			fs.mkdirSync('mydir/headers');
			fs.writeFileSync('mydir/header1.h');
			fs.writeFileSync('mydir/header2.h');
			fs.writeFileSync('mydir/lib/header1.h');
			fs.writeFileSync('mydir/headers/lib.h');

			function fileExists(name, content) {
				(0, _testSetup.expect)(fs.statSync(name).isFile()).to.be.true;
				(0, _testSetup.expect)(fs.readFileSync(name, 'utf-8')).to.equal(content);
			}

			function fileNotExists(name) {
				(0, _testSetup.expect)(fs.existsSync(name)).to.be.false;
			}

			return sut._addAdaptersImpl(callback, 'mydir/lib', 'mydir').then(function () {
				fileExists('mydir/lib/header1.h', '#include "../header1.h"');
				fileExists('mydir/lib/header2.h', '#include "../header2.h"');
				fileExists('mydir/lib/headers/lib.h', '#include "../../headers/lib.h"');
				fileExists('mydir/lib/header2.h', '#include "../header2.h"');
				fileNotExists('mydir/lib/lib/header1.h');
			});
		});

		describe('isHeaderFile', function () {
			it('.h is a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc.h')).to.be.true;
			});

			it('.hpp is a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc.hpp')).to.be.true;
			});

			it('.hxx is a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc.hxx')).to.be.true;
			});

			it('.h++ is a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc.h++')).to.be.true;
			});

			it('.cpp is not a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc.cpp')).to.be.false;
			});

			it('.c is not a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc.c')).to.be.false;
			});

			it('no extension is not a valid header file', function () {
				(0, _testSetup.expect)(sut.isHeaderFile('abc')).to.be.false;
			});
		});
	});

	describe('isLibraryExample', function () {
		var cwd = void 0;
		beforeEach(function () {
			cwd = process.cwd();
		});

		afterEach(function () {
			process.chdir(cwd);
		});

		function buildV2Library(name) {
			mkdir('mydir');
			mkdir('mydir/v2');
			var base = 'mydir/v2/' + name + '/';
			mkdir(base);
			fs.writeFileSync(base + 'library.properties', '');
			mkdir(base + 'examples');
			mkdir(base + 'examples/huzzah');
			fs.writeFileSync(base + 'examples/huzzah/code.ino', '');
			return base;
		}

		it('throws an exception when the file does not exist', function () {
			var promise = (0, _librepo_fs.isLibraryExample)('somedir');
			return promise.then(function () {
				throw Error('expected stat error');
			}).catch(function (error) {
				(0, _testSetup.expect)(error).has.property('code').equal('ENOENT');
			});
		});

		it('can successfully detect a relative example file', function () {
			var base = buildV2Library('mylib');
			var basePath = base + 'examples/huzzah';
			process.chdir(basePath);
			return (0, _testSetup.expect)((0, _librepo_fs.isLibraryExample)('code.ino')).to.eventually.eql({ basePath: path.resolve(), libraryPath: '../..', example: 'code.ino' });
		});

		it('can successfully detect an example directory from the root of the library', function () {
			var base = buildV2Library('mylib');
			var basePath = base;
			process.chdir(basePath);
			return (0, _testSetup.expect)((0, _librepo_fs.isLibraryExample)('examples/huzzah')).to.eventually.eql({ basePath: path.resolve(), libraryPath: '', example: 'examples/huzzah/' });
		});

		it('can successfully detect an example directory as the current folder', function () {
			var base = buildV2Library('mylib');
			var basePath = base + 'examples/huzzah';
			process.chdir(basePath);
			return (0, _testSetup.expect)((0, _librepo_fs.isLibraryExample)('.')).to.eventually.eql({ basePath: path.resolve(), libraryPath: '../..', example: './' });
		});

		it('can successfully detect an example file given the full path from the current folder', function () {
			var base = buildV2Library('mylib');
			var basePath = cwd;
			return (0, _testSetup.expect)((0, _librepo_fs.isLibraryExample)(base + 'examples/huzzah')).to.eventually.eql({ basePath: basePath, libraryPath: base.slice(0, -1), example: base + 'examples/huzzah/' });
		});
	});
});
//# sourceMappingURL=librepo_fs_mock.spec.js.map